/* $Id: linearize.cpp,v 1.10 2010/11/05 15:19:41 stm Exp $
 *
 * PDFlib PLOP: PDF Linearization, Optimization, Protection
 * linearization sample
 *
 */

#include <iostream>
#include <string>

#include "plop.hpp"

using namespace std;
using namespace pdflib;

int
main(void)
{
    PLOP plop;

    /* input document */
    const wstring in_filename(L"PLOP-datasheet.pdf");

    /* output document */
    const wstring out_filename(L"PLOP-datasheet-linearized.pdf");

    /* This is where input files live. Adjust as necessary. */
    const wstring searchpath(L"../data");

    try {
	int doc;
	wstring optlist;

	optlist = L"searchpath={" + searchpath + L"}";
	plop.set_option(optlist);

	/* open input file */
	if ((doc = plop.open_document(in_filename, L"")) == -1)
	{
	    wcerr << L"Error: " << plop.get_errmsg() << endl;
	    return 2;
	}

	/* create the linearized output file and add Document info entry */
	if (plop.create_file(out_filename,
		L"linearize docinfo={Author {PDFlib GmbH}}") == -1)
	{
	    wcerr << L"Error: " << plop.get_errmsg() << endl;
	    return 2;
	}

	/* close input and output files */
	plop.close_document(doc);
    }
    catch (PLOP::Exception &ex) {
	wcerr << L"PLOP exception occurred in linearize:" << endl;
	wcerr << L"[" << ex.get_errnum() << L"] " << ex.get_apiname()
		<< L": " << ex.get_errmsg() << endl;
	return 2;
    }

    return 0;
}
