/* $Id: decrypt.java,v 1.12 2011/02/23 18:34:58 rjs Exp $
 *
 * PDFlib PLOP: PDF Linearization, Optimization, Protection
 * decryption sample
 */

import java.io.*;
import com.pdflib.plop;
import com.pdflib.PLOPException;

public class decrypt
{
    public static void main (String argv[])
    {
	plop plop = null;

	try {
	    /* parameters for the input document */
	    final String in_filename = "PLOP-datasheet-encrypted.pdf";
	    final String in_password = "DEMO";
	    String optlist;

	    /* parameters for the output document */
	    final String out_filename = "PLOP-datasheet-decrypted.pdf";
	    final String out_master = "";
	    final String out_user = "";
	    final String permissions = "";
	    int doc;

	    /* This is where input files live. Adjust as necessary. */
	    final String searchpath = "../data";

	    plop = new plop();

	    optlist = "searchpath={" + searchpath + "}";
	    plop.set_option(optlist);

	    /* open protected input file with the password */
	    optlist = "password {" + in_password + "} ";
	    if ((doc = plop.open_document(in_filename, optlist)) == -1) {
		System.err.println("Error: " + plop.get_errmsg());
		plop.delete();
		System.exit(2);
	    }

	    /* create the output file */
	    optlist = "masterpassword {" + out_master + "} userpassword {" +
		out_user + "} permissions {" + permissions + "}";
	    if (plop.create_file(out_filename, optlist) == -1) {
		System.err.println("Error: " + plop.get_errmsg());
		plop.delete();
		System.exit(2);
	    }

	    /* close input and output files */
	    plop.close_document(doc);

        } catch (PLOPException e) {
            System.err.print("PLOP exception occurred in decrypt sample:\n");
            System.err.print("[" + e.get_errnum() + "] " + e.get_apiname() +
                            ": " + e.get_errmsg() + "\n");
        } catch (Exception e) {
            System.err.println(e.getMessage());
	} finally {
	    /* delete the PLOP object */
	    if (plop != null) plop.delete();
	}
    }
}
