<?php
# $Id: sign.php,v 1.12 2011/02/24 13:19:14 rjs Exp $
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# digital signature sample
#

try {
    # create a new PLOP object
    $plop = new PLOP();

    # This is where input files live. Adjust as necessary.
    $searchpath = "../data ../../data";

    $infile = "invoice.pdf";
    $outfile = "";
    $optlist;

    # alternatives for specifying the certificate
    #
    # Windows Certificate Store (Windows only):
    #    "engine=mscapi " .
    #    "digitalid={certstore={store=My subject={DEMO PLOP user 2048}}} "
    # PFX certificate from file in search path:
    #    "engine=builtin " .
    #    "digitalid={filename=demo2048.pfx} "
    # PKCS#12 certificate from file in search path:
    #    "engine=builtin " .
    #    "digitalid={filename=demo2048.p12} "
    # PKCS#11 certificate
    #    "engine=pkcs#11 " .
    #    "digitalid={filename=cryptoki.dll} "
    #
    $sign_opts = "sign={" .
	"appearance={fieldname=Signature1 } " .
        "engine=builtin " .
	"digitalid={filename=demo2048.p12} " .
	"password={demo} " .
	"reason={I agree to this document} " .
	"contactinfo={tel (123) 456 789} " .
	"location=Munich " .
	"}";

    $optlist = sprintf("searchpath={%s}", $searchpath);
    $plop->set_option($optlist);

    if (($doc = $plop->open_document($infile, "")) == 0)
    {
	die("Error: " .  $plop->get_errmsg() . "\n");
    }

    if ($plop->create_file($outfile, $sign_opts) == 0)
    {
	die("Error: " .  $plop->get_errmsg() . "\n");
    }

    $buf = $plop->get_buffer();
    $len = strlen($buf);

    header("Content-type: application/pdf");
    header("Content-Length: $len");
    header("Content-Disposition: inline; filename=decrypt.pdf");
    print $buf;

    $plop->close_document($doc);
}
catch (PLOPException $e) {
    die("PLOP exception occurred in sign sample:\n" .
	"[" . $e->get_errnum() . "] " . $e->get_apiname() . ": " .
	$e->get_errmsg() . "\n");
    }
catch (Exception $e) {
    die($e);
}

$plop = 0;
?>
